---
title: Audio()
slug: Web/API/HTMLAudioElement/Audio
tags:
  - API
  - Audio
  - Constructor
  - DOM
  - HTML
  - HTML DOM
  - HTMLAudioElement
  - Reference
  - sound
---
<p>{{APIRef("HTML DOM")}}</p>

<p><span class="seoSummary">The <code><strong>Audio()</strong></code> constructor creates and returns a new {{domxref("HTMLAudioElement")}} which can be either attached to a document for the user to interact with and/or listen to, or can be used offscreen to manage and play audio.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>audioObj</em> = new Audio(<em>url</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
	<dt><code>url</code> {{optional_inline}}</dt>
	<dd>An optional {{domxref("DOMString")}} containing the URL of an audio file to be associated with the new audio element.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A new {{domxref("HTMLAudioElement")}} object, configured to be used for playing back the audio from the file specified by <code>url</code>.The new object's {{domxref("HTMLMediaElement.preload", "preload")}} property is set to <code>auto</code> and its <code>src</code> property is set to the specified URL or <code>null</code> if no URL is given. If a URL is specified, the browser begins to <em>asynchronously</em> load the media resource before returning the new object.</p>

<ul>
</ul>

<h2 id="Usage_notes">Usage notes</h2>

<p>You can also use other element-creation methods, such as the {{domxref("document")}} object's {{domxref("Document.createElement", "createElement()")}} method, to construct a new {{domxref("HTMLAudioElement")}}.</p>

<h3 id="Determining_when_playback_can_begin">Determining when playback can begin</h3>

<p>There are three ways you can tell when enough of the audio file has loaded to allow playback to begin:</p>

<ul>
	<li>Check the value of the {{domxref("HTMLMediaElement.readyState", "readyState")}} property. If it's <code>HTMLMediaElement.HAVE_FUTURE_DATA</code>, there's enough data available to begin playback and play for at least a short time. If it's <code>HTMLMediaElement.HAVE_ENOUGH_DATA</code>, then there's enough data available that, given the current download rate, you should be able to play the audio through to the end without interruption.</li>
	<li>Listen for the {{domxref("HTMLMediaElement.canplay_event", "canplay")}} event. It is sent to the <code>&lt;audio&gt;</code> element when there's enough audio available to begin playback, although interruptions may occur).</li>
	<li>Listen for the {{domxref("HTMLMediaElement.canplaythrough_event", "canplaythrough")}} event. It is sent when it's estimated that the audio should be able to play to the end without interruption.</li>
</ul>

<p>The event-based approach is best:</p>

<pre class="brush: js">myAudioElement.addEventListener("canplaythrough", event =&gt; {
  /* the audio is now playable; play it if permissions allow */
  myAudioElement.play();
});</pre>

<h3 id="Memory_usage_and_management">Memory usage and management</h3>

<p>If all references to an audio element created using the <code>Audio()</code> constructor are deleted, the element itself won't be removed from memory by the JavaScript runtime's garbage collection mechanism if playback is currently underway. Instead, the audio will keep playing and the object will remain in memory until playback ends or is paused (such as by calling {{domxref("HTMLMediaElement.pause", "pause()")}}). At that time, the object becomes subject to garbage collection.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName('HTML WHATWG', "#dom-audio", "Audio()")}}</td>
			<td>{{Spec2('HTML WHATWG')}}</td>
			<td></td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.HTMLAudioElement.Audio")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li><a href="/en-US/docs/Web/Media">Web media technologies</a></li>
	<li>HTML element implementing this interface: {{HTMLElement("audio")}}.</li>
</ul>
